Bug 1471405 - glibc: Define O_TMPFILE macro
Summary: glibc: Define O_TMPFILE macro
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: glibc
Version: 7.5
Hardware: All
OS: Linux
unspecified
high
Target Milestone: rc
: 7.6
Assignee: DJ Delorie
QA Contact: Sergey Kolosov
URL:
Whiteboard:
Depends On: 1428677
Blocks: 1513404 1565233
TreeView+ depends on / blocked
 
Reported: 2017-07-15 16:49 UTC by Florian Weimer
Modified: 2018-10-30 09:37 UTC (History)
9 users (show)

Fixed In Version: glibc-2.17-237.el7
Doc Type: Enhancement
Doc Text:
The O_TMPFILE macro is now present in glibc headers.
Clone Of:
Environment:
Last Closed: 2018-10-30 09:36:35 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
IBM Linux Technology Center 156725 None None None 2019-04-24 19:26:42 UTC
Red Hat Bugzilla 1590228 None ON_QA kernel: openat with O_TMPFILE and mode 0 fails with EACCES (if not root) 2019-04-24 19:26:42 UTC
Red Hat Product Errata RHSA-2018:3092 None None None 2018-10-30 09:37:36 UTC

Internal Links: 1590228

Description Florian Weimer 2017-07-15 16:49:26 UTC
Bug 1330705 added support for O_TMPFILE in the open/openat implementations.  However, due to lack of kernel support at the time, the macro was not added to the install header files.

Now that O_TMPFILE kernel support is under consideration, we should considering defining O_TMPFILE, so that applications can use it.

We need to undo the changes to our patches which added __O_TMPFILE instead of O_TMPFILE, but this should be straightforward, so I'm setting the Patch keyword.

Comment 3 Hanns-Joachim Uhl 2018-02-07 19:19:15 UTC
Hello Red Hat / Florian,
quick question ...
... with the related kernel support now available in RHEL7.5
(see LTC bug 152133 - RH1428677- [7.5 FEAT] O_TMPFILE Support for RHEL 7 ...)
I would think that this bugzilla can now be processed 
(but maybe first for RHEL7.6 ..) ...
... correct ...?
Please confirm or advise ...
Thanks for your support.

Comment 4 Carlos O'Donell 2018-02-08 06:12:56 UTC
(In reply to Hanns-Joachim Uhl from comment #3)
> Hello Red Hat / Florian,
> quick question ...
> ... with the related kernel support now available in RHEL7.5
> (see LTC bug 152133 - RH1428677- [7.5 FEAT] O_TMPFILE Support for RHEL 7 ...)
> I would think that this bugzilla can now be processed 
> (but maybe first for RHEL7.6 ..) ...
> ... correct ...?
> Please confirm or advise ...
> Thanks for your support.

Yes, in RHEL 7.6 we can now consider adding O_TMPFILE.

This bug will be reviewed as we enter the RHEL 7.6 planning.

Comment 5 IBM Bug Proxy 2018-02-08 16:21:03 UTC
------- Comment From oehmes@us.ibm.com 2018-02-08 11:19 EDT-------
i am confused, the change was original accepted in 7.5, why is it now moving to 7.6 ?

Comment 6 Carlos O'Donell 2018-02-19 06:18:35 UTC
(In reply to IBM Bug Proxy from comment #5)
> ------- Comment From oehmes@us.ibm.com 2018-02-08 11:19 EDT-------
> i am confused, the change was original accepted in 7.5, why is it now moving
> to 7.6 ?

The work in glibc to define O_TMPFILE was never accepted in rhel-7.5.

The work will be reviewed again as part of our planning for rhel-7.6.

My apologies if you had any other indicator that this would be delivered in glibc in rhel-7.5. If you had such indicators, then please tell me about them, and I will review them.

There may be some confusion about the kernel side of this fix versus the glibc side of the fix.

The kernel fix is tracked separately here: https://bugzilla.redhat.com/show_bug.cgi?id=1428677, and must be delivered first before any userspace constants can be added to enable the functionality.

Comment 7 Carlos O'Donell 2018-02-19 06:20:49 UTC
(In reply to Carlos O'Donell from comment #6)
> The kernel fix is tracked separately here:
> https://bugzilla.redhat.com/show_bug.cgi?id=1428677, and must be delivered
> first before any userspace constants can be added to enable the
> functionality.

It's not entirely true that the kernel fix has to come first, but generally speaking we like to have the kernel functionality land first, then the userspace enablement. This avoids cases where applications look for the constants in configure scripts and then unconditionally enable the feature without runtime detection. Such applications would be immediately broken if we signaled via the header constant that the feature was ready for use. By staging the enablement a bit we ensure the users are likely running the latest released kernel.

Comment 11 errata-xmlrpc 2018-10-30 09:36:35 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:3092


Note You need to log in before you can comment on or make changes to this bug.